/*70-762 Lesson 1.6 Lab 3 -  Creating Tables */

/* This lab creates the CertLiveDB database, 
the Products schema within the CertLiveDB, 
and the table Products.Vendor
*/

USE master;
GO

--Delete the CertLiveDB database if it exists --
DROP DATABASE IF EXISTS CertLiveDB;
GO

--Create and Use the CertData database --

CREATE DATABASE CertLiveDB;
GO


USE CertLiveDB;
GO

--Delete the Products schema if it exists and is empty --
DROP SCHEMA IF EXISTS Products;
GO

--Create the Products schema in the CertLiveDB database --

CREATE SCHEMA Products AUTHORIZATION dbo;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Create the table Vendor in the Products schema of the CertLiveDB database --
/*
CREATE TABLE 
    [ database_name . [ schema_name ] . | schema_name . ] table_name 
    [ AS FileTable ]
    ( { <column_definition> | <computed_column_definition> 
        | <column_set_definition> | [ <table_constraint> ] 
| [ <table_index> ] [ ,...n ] } )
    [ ON { partition_scheme_name ( partition_column_name ) | filegroup 
        | "default" } ] 
    [ { TEXTIMAGE_ON { filegroup | "default" } ] 
    [ FILESTREAM_ON { partition_scheme_name | filegroup 
        | "default" } ]
    [ WITH ( <table_option> [ ,...n ] ) ]
[ ; ]

*/

--Delete the Vendor table if it exists --
DROP TABLE IF EXISTS Products.Vendor;
GO

CREATE TABLE Products.Vendor
   (VendorID int NOT NULL
		CONSTRAINT PKVendor PRIMARY KEY,
    VendorName nvarchar(50) NOT NULL,
    City nvarchar(30) NOT NULL,
    StateProvinceID int NOT NULL,
	POC nvarchar(50) NOT NULL);
GO

--SELECT VendorID, VendorName
--  FROM Products.Vendor;
--GO


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- Move Vendor table to the HumanResources schema -------------------------------

CREATE SCHEMA Humanresources;
GO

--Moves the Products.Vendor table to the HumanResources schema --
ALTER SCHEMA HumanResources TRANSFER Products.Vendor;
GO

--Moves the Vendor table back to the Products schema
ALTER SCHEMA Products TRANSFER HumanResources.Vendor;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Delete the Certification table if it exists --
DROP TABLE IF EXISTS Products.Certification;
GO

CREATE TABLE Products.Certification
   (CertID int NOT NULL
		CONSTRAINT PKCertification PRIMARY KEY,
    CertName nvarchar(50) NOT NULL,
	VendorID int NOT NULL
		CONSTRAINT FKCertification_Vendor FOREIGN KEY (CertID)
		REFERENCES Products.Vendor(VendorID));
GO


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Cleanup, if desired------------------------------------------
--Remember, a schema must be empty to be dropped---------------

DROP SCHEMA IF EXISTS HumanResources;
GO

DROP TABLE IF EXISTS Products.Vendor;
GO

DROP TABLE IF EXISTS Products.Certification;
GO

USE master;
GO

--Delete the CertData database if it exists - and if desired--
DROP DATABASE IF EXISTS CertLiveDB;
GO

