/* 70-762 Lesson 10 Lab 2 - Monitoring Lock Escalation*/

--Examine the locks in the
--Sales.Orders table when
--4990 rows are updated-----
USE WideWorldImporters;
GO


SETROWCOUNT4990
GO

BEGINTRAN;
	UPDATESales.Orders
	SETCustomerID=CustomerID+0
--Do not Rollback yet

SELECT
	request_session_id,
	resource_type,
	resource_database_id AS dbid,
	DB_NAME(resource_database_id) AS dbname,
	resource_description,
	resource_associated_entity_id,
	request_mode AS mode,
	request_status AS status
FROM sys.dm_tran_locks
WHERE resource_database_id = db_id('WideWorldImporters');
GO

----------------------------

SELECTspid,
COUNT(*),
request_mode,
[resource_associated_entity_id],
sys.dm_tran_locks.resource_typeASobject_type,
Db_name(sysprocesses.dbid)ASdbname
FROMsys.dm_tran_locks,
sys.sysprocesses
OUTERAPPLYFn_get_sql(sql_handle)
WHEREspid=51  --change as appropriate for your session
ANDsys.dm_tran_locks.request_session_id=51
ANDsys.dm_tran_locks.resource_typeIN('page','key','object')
ANDDb_name(sysprocesses.dbid)='WideWorldImporters'
GROUPBYspid,
[resource_associated_entity_id],
request_mode,
sys.dm_tran_locks.resource_type,
Db_name(sysprocesses.dbid)

------Note 4990 KEY Locks-------------------------------------
--Now Rollback the transaction and update 70000---------------
ROLLBACK TRANSACTION;

-----------------------------------------------
--New Transaction-----------------------------
--Examine the locks in the
--Sales.Orders table when
--70000 rows are updated-----
--Note the lock escalation---
SETROWCOUNT70000
GO

BEGINTRAN;
	UPDATESales.Orders
	SETCustomerID=CustomerID+0
--Do not Rollback yet


SELECTspid,
COUNT(*),
request_mode,
[resource_associated_entity_id],
sys.dm_tran_locks.resource_typeASobject_type,
Db_name(sysprocesses.dbid)ASdbname
FROMsys.dm_tran_locks,
sys.sysprocesses
OUTERAPPLYFn_get_sql(sql_handle)
WHEREspid=51 -- change as appropriate for your session
ANDsys.dm_tran_locks.request_session_id=51
ANDsys.dm_tran_locks.resource_typeIN('page','key','object')
ANDDb_name(sysprocesses.dbid)='WideWorldImporters'
GROUPBYspid,
[resource_associated_entity_id],
request_mode,
sys.dm_tran_locks.resource_type,
Db_name(sysprocesses.dbid)

------Note  Locks on the database and page-----------
-----------------------------------------------------

--Another way to monitor lock escalation is
--to set a benchmark noting the wait time
--of Intent locks (LCK_M_I*) compared to
--regular locks
--using sys.dm_os_wait_stats

SELECT
	wait_type,
	wait_time_ms,
	CONVERT(decimal(9,2), 100.0*wait_time_ms/SUM(wait_time_ms) OVER ()) AS wait_percent
FROM sys.dm_os_wait_stats
WHERE wait_type LIKE 'LCK%'
ORDER BY wait_time_ms DESC;

--Now Rollback the transaction---------------
ROLLBACK TRANSACTION;