/* 70-762 Lesson 12 Lab 1 - Using the DBCC SHOW_STATISTICS Command */

-->>>>>>>>>>
--DBCC SHOW_STATISTICS shows the actual status for a given statistic on a table or indexed view
--output composed of statistic header, the density vector and the histogram
-->>>><<<<-----------------
USE WideWorldImporters;
GO
 
DBCC SHOW_STATISTICS ('Purchasing.PurchaseOrderLines', FK_Purchasing_PurchaseOrderLines_StockItemID);
GO

--Statistics header-------------
DBCC SHOW_STATISTICS ('Purchasing.PurchaseOrderLines', 
	FK_Purchasing_PurchaseOrderLines_StockItemID)
	WITH STAT_HEADER;
GO

--Density vector-----------------
DBCC SHOW_STATISTICS ('Purchasing.PurchaseOrderLines', 
	FK_Purchasing_PurchaseOrderLines_StockItemID)
	WITH DENSITY_VECTOR;
GO

--Histogram---------------------
--representation of distribution of values
--across fixed number of intervals------------
/**
RANGE_HI_KEY
Upper bound column value for a histogram step. The column value is also called a key value.
RANGE_ROWS
Estimated number of rows whose column value falls within a histogram step, excluding the upper bound.
EQ_ROWS
Estimated number of rows whose column value equals the upper bound of the histogram step.
DISTINCT_RANGE_ROWS
Estimated number of rows with a distinct column value within a histogram step, excluding the upper bound.
AVG_RANGE_ROWS
Average number of rows with duplicate column values within a histogram step, excluding the upper bound (RANGE_ROWS / DISTINCT_RANGE_ROWS for DISTINCT_RANGE_ROWS > 0).
**/

DBCC SHOW_STATISTICS ('Purchasing.PurchaseOrderLines', 
	FK_Purchasing_PurchaseOrderLines_StockItemID)
	WITH HISTOGRAM;
GO

