/* 70-762 Lesson 13 Lab 5 - Comparing an Estimated and Actual Query Plan for a Given Query */


--Clustered Index Scan Operator and Clustered Index Seek Operator----
Use WideWorldImporters;
GO

SELECT s.StockItemID,
      s.StockItemName,
      s.SupplierID,
	  h.QuantityOnHand
FROM Warehouse.StockItems AS s
JOIN Warehouse.StockItemHoldings AS h
ON s.StockItemID = h.StockItemID
WHERE s.SupplierID = 12;
GO

--Make certain actual execution plan is not selected---
--SET SHOWPLAN_XML displays estimated query plan-------
SET SHOWPLAN_XML ON; 
GO

SELECT s.StockItemID,
      s.StockItemName,
      s.SupplierID,
	  h.QuantityOnHand
FROM Warehouse.StockItems AS s
JOIN Warehouse.StockItemHoldings AS h
ON s.StockItemID = h.StockItemID
WHERE s.SupplierID = 12;
GO



SET SHOWPLAN_XML  OFF;
GO 

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

--SET STATISTICS XML displays actual query plan-------
SET STATISTICS XML ON; 
GO

SELECT s.StockItemID,
      s.StockItemName,
      s.SupplierID,
	  h.QuantityOnHand
FROM Warehouse.StockItems AS s
JOIN Warehouse.StockItemHoldings AS h
ON s.StockItemID = h.StockItemID
WHERE s.SupplierID = 12;
GO


SET STATISTICS XML  OFF;
GO 

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
