/*70-762 Lesson 2.2 Lab 1 -  Implementing Indexes */

USE WideWorldImporters
GO


--Query uses Clustered Index Seek on OrderID-----------------------
SELECT CustomerID, OrderID, CustomerPurchaseOrderNumber, OrderDate, ExpectedDeliveryDate
FROM Sales.Orders 
WHERE OrderID BETWEEN 150 AND 500;
GO

---------------------------------------------------------------------
--Query uses Nonclustered Index Seek on CustomerID-------------------
SELECT CustomerID
FROM Sales.Orders
WHERE CustomerID > 500;
GO 

-----------------------------------------------------------------------
--Query uses Nonclustered Index Scan on CustomerPurchaseOrderNumber AND
--Lookup on Clustered Index (OrderID)----------------------------------
--Execution plan recommends creating a new index-----------------------
/*
Missing Index Details 
The Query Processor estimates that implementing the following index
could improve the query cost by 77.1437%.
*/
/*
USE [WideWorldImporters]
GO
CREATE NONCLUSTERED INDEX [<Name of Missing Index, sysname,>]
ON [Sales].[Orders] ([CustomerPurchaseOrderNumber])
INCLUDE ([OrderID],[CustomerID],[OrderDate],[ExpectedDeliveryDate])
GO
*/

SELECT CustomerID, OrderID, CustomerPurchaseOrderNumber, OrderDate, ExpectedDeliveryDate
FROM Sales.Orders 
WHERE CustomerPurchaseOrderNumber BETWEEN '12211' AND '12212'



----------------------------------------------------------
--Query uses Nonclustered Index scan IX-Sales_Orders_ContactPersonID_DateInfo
Use WideWorldImporters;
GO

SELECT CustomerPurchaseOrderNumber
FROM Sales.Orders 
WHERE CustomerPurchaseOrderNumber > 12211;
GO


---------------------------------------------------
--Query uses Clustered Index Scan and
--Sort on SalespersonPersonID----------------------
SELECT SalespersonPersonID, CustomerID, OrderID
FROM Sales.Orders 
WHERE CustomerPurchaseOrderNumber = 12211
GROUP BY SalespersonPersonID, CustomerID, OrderID
HAVING CustomerID < 500
ORDER BY SalespersonPersonID;

