/*70-762 Lesson 4.4 Lab 2 - Using Clustered Columnstore Indexes In Dimensional Data Warehouse Structures */


/**Using a clustered columnstore index in large data warehouse table**/
--WideWorldImportersDW.Fact.Order table includes a clustered
--columnstore index 
--Use Ctrl-M to Include Actual Execution Plan-----------------------

Use WideWorldImportersDW;
GO

SELECT Customer.Category,
	Date.[Calendar Month Number],
	COUNT(*) AS SalesCount,
	SUM([Total Excluding Tax]) AS TotalSales
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
JOIN
	Dimension.Customer
		ON Customer.[Customer Key] = [Order].[Customer Key]
GROUP BY Customer.Category, Date.[Calendar Month Number]
ORDER BY Customer.Category
	, Date.[Calendar Month Number]
	, SalesCount
	, TotalSales;


Use WideWorldImportersDW;
GO

SELECT Customer.[Buying Group],
	Date.[Calendar Month Number],
	COUNT(*) AS SalesCount,
	SUM([Total Excluding Tax]) AS TotalSales
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
JOIN
	Dimension.Customer
		ON Customer.[Customer Key] = [Order].[Customer Key]
GROUP BY Customer.[Buying Group], Date.[Calendar Month Number]
ORDER BY Customer.[Buying Group]
	, Date.[Calendar Month Number]
	, SalesCount
	, TotalSales;


Use WideWorldImportersDW;
GO

SELECT Customer.[Buying Group],
	Date.[Calendar Month Number],
	COUNT(*) AS SalesCount,
	SUM([Total Excluding Tax]) AS TotalSales
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
JOIN
	Dimension.Customer
		ON Customer.[Customer Key] = [Order].[Customer Key]
WHERE [Buying Group] IN ('Tailspin Toys', 'Wingtip Toys')
GROUP BY Customer.[Buying Group], Date.[Calendar Month Number]
ORDER BY Customer.[Buying Group]
	, Date.[Calendar Month Number]
	, SalesCount
	, TotalSales;
				