/*70-762 Lesson 4.7 Lab 4 - Adding Non-clustered Indexes to Clustered Columnstore Indexes */

Use WideWorldImportersDW;
GO

--/****** Object:  Index [PK_Fact_Order]   ******/
--  CONSTRAINT [PK_Fact_Order] PRIMARY KEY NONCLUSTERED 
--(
--	[Order Key] ASC,
--	[Order Date Key] ASC
--)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
--)
--GO


--/****** Object:  Index [CCX_Fact_Order] ******/
--CREATE CLUSTERED COLUMNSTORE INDEX [CCX_Fact_Order] ON [Fact].[Order] WITH (DROP_EXISTING = OFF, COMPRESSION_DELAY = 0)
--GO


Use WideWorldImportersDW;
GO

--Query uses Columnstore Index Scan--------------
SELECT [Order Key],
	Date.[Calendar Year],
	SUM ([Quantity]) AS 'Yearly Quantity'
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
GROUP BY Date.[Calendar Year],[Order Key]
ORDER BY Date.[Calendar Year],[Order Key];



--Modifying query to return one value
--Query uses nonclustered Index Seek
SELECT [Order Key],
	Date.[Calendar Year],
	SUM ([Quantity]) AS 'Yearly Quantity'
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
WHERE [Order Key] = 195550
GROUP BY Date.[Calendar Year],[Order Key]


--Modifying query to return three values
--Query uses nonclustered Index Seek
SELECT [Order Key],
	Date.[Calendar Year],
	SUM ([Quantity]) AS 'Yearly Quantity'
FROM Fact.[Order]
JOIN
	Dimension.Date
		ON Date.Date = [Order].[Order Date Key]
WHERE [Order Key] IN (195550, 125, 213455)
GROUP BY Date.[Calendar Year],[Order Key]
