/*70-762 Lesson 5 Lab 3 - Writing INSERT, UPDATE, and DELETE Statements on Tables with Constraints */

--/* 
--Uncomment the following code block to 
--create the CertLiveDB database, 
--the Production schema within the CertLiveDB database, 
--and the table Production.Products with Primary Key constraint
--*/

--/*>>>>>>>>>>>>>>>>>>BEGIN CODE BLOCK>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--USE master;
--GO

----Delete the CertLiveDB database if it exists --
--DROP DATABASE IF EXISTS CertLiveDB;


----Create and Use the CertLiveDB database --

--CREATE DATABASE CertLiveDB;
--GO
--*/

--USE CertLiveDB;
--GO


----Create the Production schema in the CertLiveDB database --
----DROP SCHEMA if it exists - but remember-----
----SCHEMA must be empty to be dropped----------
----DROP SCHEMA IF EXISTS Production------------
--DROP SCHEMA IF EXISTS Production;
--GO

CREATE SCHEMA Production AUTHORIZATION dbo;
GO

USE CertLiveDB;
GO

--------------------------------------------------------------------------------
--WORKING WITH PRIMARY KEYS AND FOREIGN KEYS------------------------------------
--------------------------------------------------------------------------------
--Create the table SkinnyProducts in the Production schema of the CertLiveDB database --
DROP TABLE IF EXISTS Production.SkinnyProducts;
GO

CREATE TABLE Production.SkinnyProducts
   (SKProductID INT  NOT NULL,
    SKProductName varchar(100) NOT NULL,
	SKCategoryType varchar(10) NULL,
    SKPrice money NULL,
	CONSTRAINT PK_SkinnyProducts_SKProductID PRIMARY KEY(SKProductID),
	);
GO

--Create Production.SkinnyCategories table --
DROP TABLE IF EXISTS Production.SkinnyCategories;
GO

CREATE TABLE Production.SkinnyCategories(
	SKCategoryType varchar(10) NOT NULL,
	SKCategoryName NVARCHAR (100),
	CONSTRAINT PK_SkinnyCategories_SKCategoryType PRIMARY KEY(SKCategoryType),
);
GO

--Create FOREIGN KEY on Production.SkinnyProducts ----------------------------------------
ALTER TABLE Production.SkinnyProducts WITH CHECK
	ADD CONSTRAINT FK_SkinnyProducts_SkinnyCategories FOREIGN KEY(SKCategoryType)
	REFERENCES Production.SkinnyCategories (SKCategoryType);
GO

--Adding more Constraints-------------------------------------
ALTER TABLE Production.SkinnyProducts 
	ADD CONSTRAINT CHK_SkinnyProducts_SKPrice
	CHECK (SKPrice BETWEEN 0 AND 100);
GO

--Add UNIQUE constraint to Production.SkinnyProducts-----------------------------------------
ALTER TABLE Production.SkinnyProducts
	ADD CONSTRAINT UQ_SkinnyProducts_SKProductName UNIQUE(SKProductName);
GO

----------------------------------------------------------------------
--Inserting multiple Items into the Tables as a Batch----------------
INSERT INTO Production.SkinnyProducts(SKProductID,SKProductName, SKCategoryType)
VALUES (1, 'A','Lean');
INSERT INTO Production.SkinnyCategories(SKCategoryType)
VALUES ('Lean');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (1, 'B', 'Lean');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (1,'C', 'LoCal');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (2, 'D', 'Lean');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (3,'E','Lean');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType, SKPrice)
VALUES (4,'F', 'SugarLess', 10);
INSERT INTO Production.SkinnyCategories(SKCategoryType)
VALUES ('SugarLess');
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType, SKPrice)
VALUES (5,'G', 'SugarLess', 200);
INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType, SKPrice)
VALUES (6,'F', 'SugarLess', 10);

--View the data in the two Skinny tables---------

SELECT *
FROM Production.SkinnyProducts;
GO

SELECT *
FROM Production.SkinnyCategories;
GO

-----------------------------------------------------
--Disable the CHECK Constraint-----------------------
ALTER TABLE Production.SkinnyProducts 
	NOCHECK CONSTRAINT CHK_SkinnyProducts_SKPrice;
GO

INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType, SKPrice)
VALUES (7,'G', 'SugarLess', 200);

--View the data in the two Skinny tables---------

SELECT *
FROM Production.SkinnyProducts;
GO

SELECT *
FROM Production.SkinnyCategories;
GO

-----------------------------------------------------------
--Disable the FOREIGN KEY Constraint-----------------------
ALTER TABLE Production.SkinnyProducts 
	NOCHECK CONSTRAINT FK_SkinnyProducts_SkinnyCategories;
GO

INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (8,'H', 'Diet');
GO

--View the data in the two Skinny tables---------

SELECT *
FROM Production.SkinnyProducts;
GO

SELECT *
FROM Production.SkinnyCategories;
GO

----------------------------------------------------------------------------
--Enable the FOREIGN KEY Constraint-----------------------
ALTER TABLE Production.SkinnyProducts 
	CHECK CONSTRAINT FK_SkinnyProducts_SkinnyCategories;
GO

INSERT INTO Production.SkinnyProducts(SKProductID, SKProductName, SKCategoryType)
VALUES (9,'J', 'Diet');
GO

--View the data in the two Skinny tables---------

SELECT *
FROM Production.SkinnyProducts;
GO

SELECT *
FROM Production.SkinnyCategories;
GO

/**************************************************/
