/* 70-762 Lesson 6 Lab 5 - Altering Stored Procedures to Streamline Logic */

USE WideWorldImporters;
GO

DROP PROC IF EXISTS Purchasing.uspSupplierInfo;
GO

CREATE PROCEDURE Purchasing.uspSupplierInfo    
AS  
    SET NOCOUNT ON;  
    SELECT s.SupplierName AS Supplier, c.SupplierCategoryName AS 'Supplier Category',
       s.PrimaryContactPersonID,
       s.PostalCityID,
       s.PhoneNumber,
       s.WebsiteURL    
	FROM Purchasing.Suppliers s
	INNER JOIN
	Purchasing.SupplierCategories c
		ON s.SupplierCategoryID = c.SupplierCategoryID
	ORDER BY s.SupplierName ASC;
GO

EXEC Purchasing.uspSupplierInfo;
GO

--ALTER PROC to contain Contact Person Name, Postal City Name, and State/Province Name---------------------
ALTER PROCEDURE Purchasing.uspSupplierInfo    
AS  
    SET NOCOUNT ON;  
    SELECT s.SupplierName AS Supplier, c.SupplierCategoryName AS 'Supplier Category',
       p.FullName AS 'Contact Person',
       cit.CityName AS City,
	   sp.StateProvinceName AS 'State/Province Name',
       s.PhoneNumber,
       s.WebsiteURL    
	FROM Purchasing.Suppliers s
	INNER JOIN
	Purchasing.SupplierCategories c
		ON s.SupplierCategoryID = c.SupplierCategoryID
	INNER JOIN
	Application.People p
		ON s.PrimaryContactPersonID = p.PersonID
	INNER JOIN
	Application.Cities cit
		ON cit.CityID = s.PostalCityID
	INNER JOIN
	Application.StateProvinces sp
		ON cit.StateProvinceID = sp.StateProvinceID
	ORDER BY s.SupplierName ASC;
GO

EXEC Purchasing.uspSupplierInfo;
GO