/* 70-762 Lesson 7 Lab 7 - Creating and Implementing Table-valued User-defined Functions */

USE WideWorldImporters;
GO


DROP FUNCTION IF EXISTS Sales.ufnFilteredCustomerTransactions;
GO

-->>>>CREATE User-Defined Table-Valued Function<<<<--------------------
--Table-Valued function filters the customer transactions
--that are between two input amounts-----------------------------------
CREATE FUNCTION Sales.ufnFilteredCustomerTransactions   --function name
(
  @mintran AS Decimal,                        --input parameters
  @maxtran AS Decimal
 )
RETURNS @returntable TABLE        --returns table
(
	CustomerID  INT
	,CustomerTransactionID INT
	,InvoiceID INT
	,TransactionDate Date
	,AmountExcludingTax  Decimal
)
AS
BEGIN                                 --begin body definition
  INSERT @returntable
	SELECT CustomerID, CustomerTransactionID, InvoiceID, TransactionDate, AmountExcludingTax
	FROM Sales.CustomerTransactions
	WHERE AmountExcludingTax BETWEEN @mintran AND @maxtran
  RETURN              --action performed returns the table with values inserted
END;
GO

-->>>>Implementing the Table-Valued Function<<<<--------------------
--Finding the customers with large transactions - between 20,000 and 40,000 amount----
SELECT CustomerID, AmountExcludingTax AS 'Transaction Amount', TransactionDate, CustomerTransactionID, InvoiceID  
FROM Sales.ufnFilteredCustomerTransactions (20000.00,40000.00)
ORDER BY CustomerID, [Transaction Amount] DESC;

