/* 70-762 Lesson 7 Lab 8 - Implementing Deterministic and Non-deterministic Functions */

USE WideWorldImporters;
GO

DROP FUNCTION IF EXISTS Sales.ufnCustOutstandingBalance;
GO

--DETERMINISTIC FUNCTION EXAMPLE-----------------------
--Create Scalar user-defined function to diplay sum of
--outstanding balances of customers on a given day
CREATE OR ALTER FUNCTION Sales.ufnCustOutstandingBalance    
(@TransactionDate datetime)                   
RETURNS decimal                               
 AS
 BEGIN                                        
	DECLARE @ret decimal;
	SELECT @ret = SUM(ct.OutstandingBalance)
	FROM Sales.CustomerTransactions AS ct
	WHERE ct.TransactionDate = @TransactionDate;
	RETURN @ret;                              
END;
GO

--Total balance outstanding for a given day-------------------------------------------
SELECT DISTINCT TransactionDate, 
                Sales.ufnCustOutstandingBalance(TransactionDate) AS 'Total Customer Balance Outstanding for Day'
FROM Sales.CustomerTransactions
WHERE TransactionDate = '2016-05-31';
GO

-->>>>Nondeterministic Built-in Function<<<<-----------------------------
-- Create local variable with DECLARE/SET syntax; using NEWID() function
--  Run the code more than once to show nondeterminism of NEW()-------------------

DECLARE @testid uniqueidentifier, @testcount INT
SET @testcount = 1

WHILE @testcount<= 5
	BEGIN
		SET @testid = NEWID()
		PRINT 'Value of the testid is: '+ CONVERT(varchar(255), @testid);
		SET @testcount +=1
	END;


GO