/* 70-762 Lesson 7 Lab 1 - Creating and Implementing Triggers */


-- SQL Server Syntax  
-- Trigger on an INSERT, UPDATE, or DELETE statement to a table or view (DML Trigger)  

--CREATE [ OR ALTER ] TRIGGER [ schema_name . ]trigger_name   
--ON { table | view }   
--[ WITH <dml_trigger_option> [ ,...n ] ]  
--{ FOR | AFTER | INSTEAD OF }   
--{ [ INSERT ] [ , ] [ UPDATE ] [ , ] [ DELETE ] }   
--[ WITH APPEND ]  
--[ NOT FOR REPLICATION ]   
--AS { sql_statement  [ ; ] [ ,...n ] | EXTERNAL NAME <method specifier [ ; ] > }  

--<dml_trigger_option> ::=  
--    [ ENCRYPTION ]  
--    [ EXECUTE AS Clause ]  

--<method_specifier> ::=  
--    assembly_name.class_name.method_name


/* The following catalog views provide information
   on triggers in the AdventureWorks2016CTP3 database
   */

USE AdventureWorks2016CTP3;
GO 

SELECT  name, parent_id, create_date, modify_date, is_instead_of_trigger  
FROM sys.triggers  
WHERE type = 'TR';   
GO

SELECT object_id, type, type_desc, is_trigger_event, event_group_type, event_group_type_desc   
FROM sys.events  
WHERE object_id = OBJECT_ID('HumanResources.dEmployee'); --Employee cannot be deleted  
GO

USE AdventureWorks2016CTP3;   
GO 
 
SELECT object_id, type, type_desc, is_trigger_event, event_group_type, event_group_type_desc   
FROM sys.events  
WHERE object_id = OBJECT_ID('Person.iuPerson');  --Insert, Update  
GO

USE [AdventureWorks2016CTP3]
GO

/****** Object:  Trigger [HumanResources].[dEmployee] ******/
--INSTEAD OF DML trigger to prevent employees
--from being deleted from the HumanResources.Employees 
--table

--SET ANSI_NULLS ON
--GO

--SET QUOTED_IDENTIFIER ON
--GO


--CREATE OR ALTER TRIGGER [HumanResources].[dEmployee] ON [HumanResources].[Employee] 
--INSTEAD OF DELETE NOT FOR REPLICATION AS 
--BEGIN
--    DECLARE @Count int;

--    SET @Count = @@ROWCOUNT;
--    IF @Count = 0 
--        RETURN;

--    SET NOCOUNT ON;

--    BEGIN
--        RAISERROR
--            (N'Employees cannot be deleted. They can only be marked as not current.', -- Message
--            10, -- Severity.
--            1); -- State.

--        -- Rollback any active or uncommittable transactions
--        IF @@TRANCOUNT > 0
--        BEGIN
--            ROLLBACK TRANSACTION;
--        END
--    END;
--END;

--GO

--ALTER TABLE [HumanResources].[Employee] ENABLE TRIGGER [dEmployee]
--GO

--EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'INSTEAD OF DELETE trigger which keeps Employees from being deleted.' , @level0type=N'SCHEMA',@level0name=N'HumanResources', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'TRIGGER',@level2name=N'dEmployee'
--GO

--Query that fires the dEmployee trigger

DELETE FROM HumanResources.Employee
WHERE LoginID = 'adventure-works\rob0';
