/* 70-762 Lesson 7 Lab 3 - Implementing DDL Triggers */

USE CertLiveDB;
GO

--Create a new table for the lab----------------
DROP TABLE IF EXISTS Production.SkinnyProductsCopy;
GO 

SELECT *
INTO Production.SkinnyProductsCopy
FROM Production.SkinnyProducts;
GO

--Create a DDL database trigger to prevent
--dropping or altering tables in the CertLiveDB database
DROP TRIGGER IF EXISTS trFailSafe;
GO

CREATE TRIGGER trFailSafe   
ON DATABASE   
FOR DROP_TABLE, ALTER_TABLE   
AS   
   PRINT 'You must disable Trigger "trFailSafe" to drop or alter tables in this database!'   
   ROLLBACK;

--Try dropping a table once the trigger is implemented
DROP TABLE CertLiveDB.Production.SkinnyProductsCopy;
GO

--Disable the trigger so the table can be dropped or altered
DISABLE TRIGGER trFailSafe 
ON DATABASE;
GO

--Try dropping the table again
DROP TABLE CertLiveDB.Production.SkinnyProductsCopy;
GO

--Enable the trigger
ENABLE TRIGGER trFailSafe 
ON DATABASE;
GO

--At this point I just recreated the 'copy' table but
--you can use any table in the database to determine if
--the trigger prevents dropping or altering a table
SELECT *
INTO Production.SkinnyProductsCopy
FROM Production.SkinnyProducts;
GO

--Implement dropping a table------
DROP TABLE CertLiveDB.Production.SkinnyProductsCopy;
GO

--Implement altering a table----
ALTER TABLE CertLiveDB.Production.SkinnyProductsCopy
  ALTER COLUMN SKCategoryType varchar(50);
GO

--Drop the trigger----------------------
DROP TRIGGER IF EXISTS trFailSafe;
GO