/* 70-762 Lesson 7 Lab 4 - Implementing Logon Triggers */

--This logon trigger denies the user TestUser
--from logging into the server if the 
--user already has  three user sessions created


USE master;  
GO 
 
CREATE LOGIN TestUser WITH PASSWORD = 'PASSWORD$1';   
GO  

GRANT VIEW SERVER STATE TO TestUser;  
GO 

DROP TRIGGER IF EXISTS trLimitConnections;
GO
 
CREATE TRIGGER trLimitConnections  
  ON ALL SERVER WITH EXECUTE AS 'TestUser'  
FOR LOGON  
AS  
BEGIN
  --ORIGINAL_LOGIN function returns identity of login that first connects to SQL Server in this session  
  IF ORIGINAL_LOGIN()= 'TestUser'   
     AND  
    (SELECT COUNT(*) FROM sys.dm_exec_sessions --DMV showing information about all active user connections  
            WHERE is_user_process = 1 AND  
                original_login_name = 'TestUser') > 3  
    ROLLBACK;  
END;


DROP LOGIN TestUser;

----------------------------------------------
----------------------------------------------
SELECT *
FROM sys.server_trigger_events;
GO

SELECT *
FROM sys.server_triggers;
GO
